Loading...
Searching...
No Matches
irr::core::triangle3d< T > Class Template Reference

3d triangle template class for doing collision detection and other things. More...

`#include <triangle3d.h>`

## Public Member Functions

| triangle3d ()
| Constructor for an all 0 triangle.
| triangle3d (vector3d< T > v1, vector3d< T > v2, vector3d< T > v3)
| Constructor for triangle with given three vertices.
core::vector3d< T > | closestPointOnTriangle (const core::vector3d< T > &p) const
| Get the closest point on a triangle to a point on the same plane.
T | getArea () const
| Get the area of the triangle.
bool | getIntersectionOfPlaneWithLine (const vector3d< T > &linePoint, const vector3d< T > &lineVect, vector3d< T > &outIntersection) const
| Calculates the intersection between a 3d line and the plane the triangle is on.
bool | getIntersectionWithLimitedLine (const line3d< T > &line, vector3d< T > &outIntersection) const
| Get an intersection with a 3d line.
bool | getIntersectionWithLine (const vector3d< T > &linePoint, const vector3d< T > &lineVect, vector3d< T > &outIntersection) const
| Get an intersection with a 3d line.
vector3d< T > | getNormal () const
| Get the normal of the triangle.
plane3d< T > | getPlane () const
| Get the plane of this triangle.
bool | isFrontFacing (const vector3d< T > &lookDirection) const
| Test if the triangle would be front or backfacing from any point.
bool | isPointInside (const vector3d< T > &p) const
| Check if a point is inside the triangle (border-points count also as inside).
bool | isPointInsideFast (const vector3d< T > &p) const
| Check if a point is inside the triangle (border-points count also as inside).
bool | isTotalInsideBox (const aabbox3d< T > &box) const
| Determines if the triangle is totally inside a bounding box.
bool | isTotalOutsideBox (const aabbox3d< T > &box) const
| Determines if the triangle is totally outside a bounding box.
bool | operator!= (const triangle3d< T > &other) const
| Inequality operator.
bool | operator== (const triangle3d< T > &other) const
| Equality operator.
void | set (const core::vector3d< T > &a, const core::vector3d< T > &b, const core::vector3d< T > &c)
| sets the triangle's points

## Public Attributes

vector3d< T > | pointA
| the three points of the triangle
vector3d< T > | pointB
vector3d< T > | pointC

## Detailed Description

template<class T>
class irr::core::triangle3d< T >

3d triangle template class for doing collision detection and other things.

Definition at line 20 of file triangle3d.h.

## Constructor & Destructor Documentation

## triangle3d() [1/2]

template<class T>

irr::core::triangle3d< T >::triangle3d | ( |  | ) |

inline

Constructor for an all 0 triangle.

Definition at line 25 of file triangle3d.h.

## triangle3d() [2/2]

template<class T>

irr::core::triangle3d< T >::triangle3d | ( | vector3d< T > | v1,
|  | vector3d< T > | v2,
|  | vector3d< T > | v3 )

inline

Constructor for triangle with given three vertices.

Definition at line 27 of file triangle3d.h.

## Member Function Documentation

## closestPointOnTriangle()

template<class T>

core::vector3d< T > irr::core::triangle3d< T >::closestPointOnTriangle | ( | const core::vector3d< T > & | p | ) | const

inline

Get the closest point on a triangle to a point on the same plane.

Parameters

  p | Point which must be on the same plane as the triangle.

Returns
  The closest point of the triangle

Definition at line 68 of file triangle3d.h.

## getArea()

template<class T>

T irr::core::triangle3d< T >::getArea | ( |  | ) | const

inline

Get the area of the triangle.

Definition at line 224 of file triangle3d.h.

## getIntersectionOfPlaneWithLine()

template<class T>

bool irr::core::triangle3d< T >::getIntersectionOfPlaneWithLine | ( | const vector3d< T > & | linePoint,
|  | const vector3d< T > & | lineVect,
|  | vector3d< T > & | outIntersection ) const

inline

Calculates the intersection between a 3d line and the plane the triangle is on.

Parameters

  lineVect | Vector of the line to intersect with.
  linePoint | Point of the line to intersect with.
  outIntersection | Place to store the intersection point, if there is one.

Returns
  True if there was an intersection, else false.

Definition at line 169 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::getIntersectionWithLine().

## getIntersectionWithLimitedLine()

template<class T>

bool irr::core::triangle3d< T >::getIntersectionWithLimitedLine | ( | const line3d< T > & | line,
|  | vector3d< T > & | outIntersection ) const

inline

Get an intersection with a 3d line.

Parameters

  line | Line to intersect with.
  outIntersection | Place to store the intersection point, if there is one.

Returns
  True if there was an intersection, false if not.

Definition at line 136 of file triangle3d.h.

## getIntersectionWithLine()

template<class T>

bool irr::core::triangle3d< T >::getIntersectionWithLine | ( | const vector3d< T > & | linePoint,
|  | const vector3d< T > & | lineVect,
|  | vector3d< T > & | outIntersection ) const

inline

Get an intersection with a 3d line.

Please note that also points are returned as intersection which are on the line, but not between the start and end point of the line. If you want the returned point be between start and end use getIntersectionWithLimitedLine().

Parameters

  linePoint | Point of the line to intersect with.
  lineVect | Vector of the line to intersect with.
  outIntersection | Place to store the intersection point, if there is one.

Returns
  True if there was an intersection, false if there was not.

Definition at line 154 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::getIntersectionWithLimitedLine().

## getNormal()

template<class T>

vector3d< T > irr::core::triangle3d< T >::getNormal | ( |  | ) | const

inline

Get the normal of the triangle.

Please note: The normal is not always normalized.

Definition at line 199 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::getIntersectionOfPlaneWithLine(), and irr::core::triangle3d< f32 >::isFrontFacing().

## getPlane()

template<class T>

plane3d< T > irr::core::triangle3d< T >::getPlane | ( |  | ) | const

inline

Get the plane of this triangle.

Definition at line 218 of file triangle3d.h.

## isFrontFacing()

template<class T>

bool irr::core::triangle3d< T >::isFrontFacing | ( | const vector3d< T > & | lookDirection | ) | const

inline

Test if the triangle would be front or backfacing from any point.

Thus, this method assumes a camera position from which the triangle is definitely visible when looking at the given direction. Do not use this method with points as it will give wrong results!

Parameters

  lookDirection | Look direction.

Returns
  True if the plane is front facing and false if it is backfacing.

Definition at line 210 of file triangle3d.h.

## isPointInside()

template<class T>

bool irr::core::triangle3d< T >::isPointInside | ( | const vector3d< T > & | p | ) | const

inline

Check if a point is inside the triangle (border-points count also as inside).

Definition at line 89 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::getIntersectionWithLine().

## isPointInsideFast()

template<class T>

bool irr::core::triangle3d< T >::isPointInsideFast | ( | const vector3d< T > & | p | ) | const

inline

Check if a point is inside the triangle (border-points count also as inside).

This method uses a barycentric coordinate system. It is faster than isPointInside but is more susceptible to floating point rounding errors. This will especially be noticable when the FPU is in single precision mode (which is for example set on default by Direct3D).

Parameters

  p | Point to test. Assumes that this point is already on the plane of the triangle.

Returns
  True if point is inside the triangle, otherwise false.

Definition at line 108 of file triangle3d.h.

## isTotalInsideBox()

template<class T>

bool irr::core::triangle3d< T >::isTotalInsideBox | ( | const aabbox3d< T > & | box | ) | const

inline

Determines if the triangle is totally inside a bounding box.

Parameters

  box | Box to check.

Returns
  True if triangle is within the box, otherwise false.

Definition at line 44 of file triangle3d.h.

## isTotalOutsideBox()

template<class T>

bool irr::core::triangle3d< T >::isTotalOutsideBox | ( | const aabbox3d< T > & | box | ) | const

inline

Determines if the triangle is totally outside a bounding box.

Parameters

  box | Box to check.

Returns
  True if triangle is outside the box, otherwise false.

Definition at line 54 of file triangle3d.h.

## operator!=()

template<class T>

bool irr::core::triangle3d< T >::operator!= | ( | const triangle3d< T > & | other | ) | const

inline

Inequality operator.

Definition at line 36 of file triangle3d.h.

## operator==()

template<class T>

bool irr::core::triangle3d< T >::operator== | ( | const triangle3d< T > & | other | ) | const

inline

Equality operator.

Definition at line 30 of file triangle3d.h.

## set()

template<class T>

void irr::core::triangle3d< T >::set | ( | const core::vector3d< T > & | a,
|  | const core::vector3d< T > & | b,
|  | const core::vector3d< T > & | c )

inline

sets the triangle's points

Definition at line 231 of file triangle3d.h.

## Member Data Documentation

## pointA

template<class T>

vector3d<T> irr::core::triangle3d< T >::pointA

the three points of the triangle

Definition at line 239 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::getIntersectionOfPlaneWithLine(), and irr::core::triangle3d< f32 >::operator==().

## pointB

template<class T>

vector3d<T> irr::core::triangle3d< T >::pointB

Definition at line 240 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::operator==().

## pointC

template<class T>

vector3d<T> irr::core::triangle3d< T >::pointC

Definition at line 241 of file triangle3d.h.

Referenced by irr::core::triangle3d< f32 >::operator==().

The documentation for this class was generated from the following file:

- triangle3d.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0